diff -Nru jdk24u-jdk-24-29.orig/make/modules/jdk.management/Lib.gmk jdk24u-jdk-24-29/make/modules/jdk.management/Lib.gmk
--- jdk24u-jdk-24-29.orig/make/modules/jdk.management/Lib.gmk	2024-12-29 15:19:40.958221433 +0100
+++ jdk24u-jdk-24-29/make/modules/jdk.management/Lib.gmk	2024-12-29 15:20:25.061284036 +0100
@@ -37,7 +37,7 @@
 endif
 
 LIBMANAGEMENT_EXT_OPTIMIZATION := HIGH
-ifeq ($(call isTargetOs, linux)+$(COMPILE_WITH_DEBUG_SYMBOLS), true+true)
+ifeq ($(call isTargetOs, solaris linux)+$(COMPILE_WITH_DEBUG_SYMBOLS), true+true)
   LIBMANAGEMENT_EXT_OPTIMIZATION := LOW
 endif
 
@@ -49,6 +49,7 @@
     DISABLED_WARNINGS_clang_UnixOperatingSystem.c := format-nonliteral, \
     CFLAGS := $(LIBMANAGEMENT_EXT_CFLAGS), \
     JDK_LIBS := java.base:libjava java.base:libjvm, \
+    LIBS_solaris := -lkstat, \
     LIBS_aix := -lperfstat, \
     LIBS_windows := advapi32.lib psapi.lib, \
 ))
diff -Nru jdk24u-jdk-24-29.orig/make/modules/jdk.management.agent/Lib.gmk jdk24u-jdk-24-29/make/modules/jdk.management.agent/Lib.gmk
--- jdk24u-jdk-24-29.orig/make/modules/jdk.management.agent/Lib.gmk	2024-12-29 15:19:40.965748005 +0100
+++ jdk24u-jdk-24-29/make/modules/jdk.management.agent/Lib.gmk	2024-12-29 15:20:25.061653179 +0100
@@ -32,7 +32,7 @@
 $(eval $(call SetupJdkLibrary, BUILD_LIBMANAGEMENT_AGENT, \
     NAME := management_agent, \
     OPTIMIZATION := LOW, \
-    JDK_LIBS := java.base:libjava, \
+    JDK_LIBS := java.base:libjava java.base:libjvm, \
     LIBS_windows := advapi32.lib, \
 ))
 
diff -Nru jdk24u-jdk-24-29.orig/make/modules/jdk.net/Lib.gmk jdk24u-jdk-24-29/make/modules/jdk.net/Lib.gmk
--- jdk24u-jdk-24-29.orig/make/modules/jdk.net/Lib.gmk	2024-12-29 15:19:40.969538777 +0100
+++ jdk24u-jdk-24-29/make/modules/jdk.net/Lib.gmk	2024-12-29 15:20:25.062061531 +0100
@@ -29,6 +29,8 @@
 ## Build libextnet
 ################################################################################
 
+ifeq ($(call isTargetOs, solaris), false)
+
 $(eval $(call SetupJdkLibrary, BUILD_LIBEXTNET, \
     NAME := extnet, \
     OPTIMIZATION := LOW, \
@@ -38,3 +40,5 @@
 ))
 
 TARGETS += $(BUILD_LIBEXTNET)
+
+endif
diff -Nru jdk24u-jdk-24-29.orig/make/modules/jdk.sctp/Lib.gmk jdk24u-jdk-24-29/make/modules/jdk.sctp/Lib.gmk
--- jdk24u-jdk-24-29.orig/make/modules/jdk.sctp/Lib.gmk	2024-12-29 15:19:40.963373042 +0100
+++ jdk24u-jdk-24-29/make/modules/jdk.sctp/Lib.gmk	2024-12-29 15:20:25.062432619 +0100
@@ -40,6 +40,7 @@
           java.base:libnio/ch, \
       JDK_LIBS := java.base:libjava java.base:libnet, \
       LIBS_linux := $(LIBDL) -lpthread, \
+      LIBS_solaris := -lsocket, \
   ))
 
   TARGETS += $(BUILD_LIBSCTP)
diff -Nru jdk24u-jdk-24-29.orig/make/RunTestsPrebuilt.gmk jdk24u-jdk-24-29/make/RunTestsPrebuilt.gmk
--- jdk24u-jdk-24-29.orig/make/RunTestsPrebuilt.gmk	2024-12-29 15:19:40.972763429 +0100
+++ jdk24u-jdk-24-29/make/RunTestsPrebuilt.gmk	2024-12-29 15:20:25.047687299 +0100
@@ -168,6 +168,8 @@
     OPENJDK_TARGET_OS := linux
   else ifeq ($(UNAME_OS), Darwin)
     OPENJDK_TARGET_OS := macosx
+  else ifeq ($(UNAME_OS), SunOS)
+    OPENJDK_TARGET_OS := solaris
   else
     OPENJDK_TARGET_OS := $(UNAME_OS)
   endif
@@ -180,15 +182,28 @@
 # Assume little endian unless otherwise specified
 OPENJDK_TARGET_CPU_ENDIAN := little
 
-UNAME_CPU := $(shell $(UNAME) -m)
-ifeq ($(UNAME_CPU), i686)
-  OPENJDK_TARGET_CPU := x86
-  OPENJDK_TARGET_CPU_BITS := 32
-else
-  # Assume all others are 64-bit. We use the same CPU name as uname for
-  # at least x86_64 and aarch64.
-  OPENJDK_TARGET_CPU := $(UNAME_CPU)
+ifeq ($(OPENJDK_TARGET_OS), solaris)
+  # On solaris, use uname -p
+  UNAME_CPU := $(shell $(UNAME) -p)
+  # Assume 64-bit platform
   OPENJDK_TARGET_CPU_BITS := 64
+  ifeq ($(UNAME_CPU), i386)
+    OPENJDK_TARGET_CPU := x86_64
+  else
+    OPENJDK_TARGET_CPU := $(UNAME_CPU)
+  endif
+else
+  # ... all others use uname -m
+  UNAME_CPU := $(shell $(UNAME) -m)
+  ifeq ($(UNAME_CPU), i686)
+    OPENJDK_TARGET_CPU := x86
+    OPENJDK_TARGET_CPU_BITS := 32
+  else
+    # Assume all others are 64-bit. We use the same CPU name as uname for
+    # at least x86_64 and aarch64.
+    OPENJDK_TARGET_CPU := $(UNAME_CPU)
+    OPENJDK_TARGET_CPU_BITS := 64
+  endif
 endif
 
 OPENJDK_TARGET_CPU_ARCH := $(OPENJDK_TARGET_CPU)
@@ -213,6 +228,11 @@
 else ifeq ($(OPENJDK_TARGET_OS), macosx)
   NUM_CORES := $(shell /usr/sbin/sysctl -n hw.ncpu)
   MEMORY_SIZE := $(shell $(EXPR) `/usr/sbin/sysctl -n hw.memsize` / 1024 / 1024)
+else ifeq ($(OPENJDK_TARGET_OS), solaris)
+  NUM_CORES := $(shell /usr/sbin/psrinfo -v | $(GREP) -c on-line)
+  MEMORY_SIZE := $(shell \
+      /usr/sbin/prtconf 2> /dev/null | $(GREP) "^Memory [Ss]ize" | $(AWK) '{print $$3}' \
+  )
 else ifeq ($(OPENJDK_TARGET_OS), windows)
   NUM_CORES := $(NUMBER_OF_PROCESSORS)
   MEMORY_SIZE := $(shell \
diff -Nru jdk24u-jdk-24-29.orig/make/RunTestsPrebuiltSpec.gmk jdk24u-jdk-24-29/make/RunTestsPrebuiltSpec.gmk
--- jdk24u-jdk-24-29.orig/make/RunTestsPrebuiltSpec.gmk	2024-12-29 15:19:40.502513991 +0100
+++ jdk24u-jdk-24-29/make/RunTestsPrebuiltSpec.gmk	2024-12-29 15:20:25.048055505 +0100
@@ -173,6 +173,16 @@
 FILE := file
 ULIMIT := ulimit
 
+# On Solaris gnu versions of some tools are required.
+ifeq ($(OPENJDK_BUILD_OS), solaris)
+  AWK := gawk
+  GREP := ggrep
+  EGREP := ggrep -E
+  FGREP := grep -F
+  SED := gsed
+  TAR := gtar
+endif
+
 ifeq ($(OPENJDK_BUILD_OS), windows)
   PATHTOOL := cygpath
 endif
diff -Nru jdk24u-jdk-24-29.orig/make/scripts/compare.sh jdk24u-jdk-24-29/make/scripts/compare.sh
--- jdk24u-jdk-24-29.orig/make/scripts/compare.sh	2024-12-29 15:19:40.999058715 +0100
+++ jdk24u-jdk-24-29/make/scripts/compare.sh	2024-12-29 15:20:25.063307605 +0100
@@ -75,7 +75,14 @@
 # Disassembly diff filters. These filters try to filter out ephemeral parts of the
 # disassembly, such as hard-coded addresses, to be able to catch "actual" differences.
 
-if [ "$OPENJDK_TARGET_OS" = "windows" ]; then
+if [ "$OPENJDK_TARGET_OS" = "solaris" ]; then
+  if [ "$OPENJDK_TARGET_CPU" = "x86_64" ]; then
+    # Random strings looking like this differ: <.XAKoKoPIac2W0OA.
+    DIS_DIFF_FILTER="$SED \
+        -e 's/<\.[A-Za-z0-9]\{\15}\./<.SYM./' \
+        "
+  fi
+elif [ "$OPENJDK_TARGET_OS" = "windows" ]; then
   DIS_DIFF_FILTER="$SED -r \
       -e 's/^  [0-9A-F]{16}: //' \
       -e 's/\[[0-9A-F]{4,16}h\]/[<HEXSTR>]/' \
@@ -385,7 +392,14 @@
     fi
 
     CONTENTS_DIFF_FILE=$WORK_DIR/$ZIP_FILE.diff
-    $DIFF -rq $OTHER_UNZIPDIR $THIS_UNZIPDIR > $CONTENTS_DIFF_FILE
+    # On solaris, there is no -q option.
+    if [ "$OPENJDK_TARGET_OS" = "solaris" ]; then
+        $DIFF -r $OTHER_UNZIPDIR $THIS_UNZIPDIR \
+            | $GREP -v -e "^<" -e "^>" -e "^Common subdirectories:" \
+            > $CONTENTS_DIFF_FILE
+    else
+        $DIFF -rq $OTHER_UNZIPDIR $THIS_UNZIPDIR > $CONTENTS_DIFF_FILE
+    fi
 
     ONLY_OTHER=$($GREP "^Only in $OTHER_UNZIPDIR" $CONTENTS_DIFF_FILE)
     ONLY_THIS=$($GREP "^Only in $THIS_UNZIPDIR" $CONTENTS_DIFF_FILE)
@@ -407,8 +421,14 @@
     fi
 
     if [ "$CMP_ZIPS_CONTENTS" = "true" ]; then
-        DIFFING_FILES=$($GREP -e "differ$" $CONTENTS_DIFF_FILE \
-            | $CUT -f 2 -d ' ' | $SED "s|$OTHER_UNZIPDIR/||g")
+        if [ "$OPENJDK_TARGET_OS" = "solaris" ]; then
+            DIFFING_FILES=$($GREP -e 'differ$' -e '^diff ' $CONTENTS_DIFF_FILE \
+                | $SED -e 's/^Files //g' -e 's/diff -r //g' | $CUT -f 1 -d ' ' \
+                | $SED "s|$OTHER_UNZIPDIR/||g")
+        else
+            DIFFING_FILES=$($GREP -e "differ$" $CONTENTS_DIFF_FILE \
+                | $CUT -f 2 -d ' ' | $SED "s|$OTHER_UNZIPDIR/||g")
+        fi
 
         # Separate executable/library files from other files in zip.
         DIFFING_TEXT_FILES=
@@ -756,6 +776,10 @@
         # to filter out that extra information.
         $DUMPBIN -exports $OTHER_FILE | $GREP  -E '^ +[0-9A-F]+ +[0-9A-F]+ [0-9A-F]+' | sed 's/ = .*//g' | cut -c27- | $SYM_SORT_CMD > $WORK_FILE_BASE.symbols.other
         $DUMPBIN -exports $THIS_FILE  | $GREP  -E '^ +[0-9A-F]+ +[0-9A-F]+ [0-9A-F]+' | sed 's/ = .*//g' | cut -c27- | $SYM_SORT_CMD > $WORK_FILE_BASE.symbols.this
+    elif [ "$OPENJDK_TARGET_OS" = "solaris" ]; then
+        # Some symbols get seemingly random 15 character prefixes. Filter them out.
+        $NM -a $ORIG_OTHER_FILE 2> /dev/null | $GREP -v $NAME | $AWK '{print $2, $3, $4, $5}' | $SED 's/^\([a-zA-Z] [\.\$]\)[a-zA-Z0-9_\$]\{15,15\}\./\1./g' | $SYM_SORT_CMD > $WORK_FILE_BASE.symbols.other
+        $NM -a $ORIG_THIS_FILE  2> /dev/null | $GREP -v $NAME | $AWK '{print $2, $3, $4, $5}' | $SED 's/^\([a-zA-Z] [\.\$]\)[a-zA-Z0-9_\$]\{15,15\}\./\1./g' | $SYM_SORT_CMD > $WORK_FILE_BASE.symbols.this
     elif [ "$OPENJDK_TARGET_OS" = "aix" ]; then
         $OBJDUMP -T $ORIG_OTHER_FILE 2> /dev/null | $GREP -v $NAME | $AWK '{print $2, $3, $4, $5}' | $SYM_SORT_CMD > $WORK_FILE_BASE.symbols.other
         $OBJDUMP -T $ORIG_THIS_FILE  2> /dev/null | $GREP -v $NAME | $AWK '{print $2, $3, $4, $5}' | $SYM_SORT_CMD > $WORK_FILE_BASE.symbols.this
diff -Nru jdk24u-jdk-24-29.orig/make/scripts/hide_important_warnings_from_javac.sh jdk24u-jdk-24-29/make/scripts/hide_important_warnings_from_javac.sh
--- jdk24u-jdk-24-29.orig/make/scripts/hide_important_warnings_from_javac.sh	2024-12-29 15:19:40.998265976 +0100
+++ jdk24u-jdk-24-29/make/scripts/hide_important_warnings_from_javac.sh	2024-12-29 15:20:25.063631963 +0100
@@ -22,8 +22,13 @@
 # questions.
 #
 
-GREP=grep
-
+if [ -x /usr/bin/ggrep ] ; then
+    # Gnu grep on Solaris
+    # (reference configure and build/solaris-i586-clientANDserver-release/spec.gmk
+    GREP=/usr/bin/ggrep
+else
+    GREP=grep
+fi
 #
 EXP="Note: Some input files use or override a deprecated API."
 EXP="${EXP}|Note: Recompile with -Xlint:deprecation for details."
diff -Nru jdk24u-jdk-24-29.orig/make/test/JtregNativeHotspot.gmk jdk24u-jdk-24-29/make/test/JtregNativeHotspot.gmk
--- jdk24u-jdk-24-29.orig/make/test/JtregNativeHotspot.gmk	2024-12-29 15:19:40.972190461 +0100
+++ jdk24u-jdk-24-29/make/test/JtregNativeHotspot.gmk	2024-12-29 15:20:25.064365661 +0100
@@ -883,6 +883,10 @@
 BUILD_HOTSPOT_JTREG_LIBRARIES_JDK_LIBS_libatExit := java.base:libjvm
 BUILD_HOTSPOT_JTREG_EXECUTABLES_JDK_LIBS_exedaemonDestroy := java.base:libjvm
 
+ifeq ($(call isTargetOs, solaris), true)
+    BUILD_HOTSPOT_JTREG_EXCLUDE += libterminatedThread.c
+endif
+
 ifeq ($(call isTargetOs, windows), true)
   BUILD_HOTSPOT_JTREG_EXECUTABLES_CFLAGS_exeFPRegs := -MT
   BUILD_HOTSPOT_JTREG_EXCLUDE += exesigtest.c libterminatedThread.c libTestJNI.c libCompleteExit.c libMonitorWithDeadObjectTest.c libTestPsig.c exeGetCreatedJavaVMs.c libTestUnloadedClass.cpp
diff -Nru jdk24u-jdk-24-29.orig/make/test/JtregNativeJdk.gmk jdk24u-jdk-24-29/make/test/JtregNativeJdk.gmk
--- jdk24u-jdk-24-29.orig/make/test/JtregNativeJdk.gmk	2024-12-29 15:19:40.972486023 +0100
+++ jdk24u-jdk-24-29/make/test/JtregNativeJdk.gmk	2024-12-29 15:20:25.064883320 +0100
@@ -60,10 +60,10 @@
 BUILD_JDK_JTREG_EXECUTABLES_JDK_LIBS_exeCallerAccessTest := java.base:libjvm
 BUILD_JDK_JTREG_EXECUTABLES_JDK_LIBS_exeNullCallerTest := java.base:libjvm
 
-BUILD_JDK_JTREG_LIBRARIES_JDK_LIBS_libstringPlatformChars := java.base:libjava
+BUILD_JDK_JTREG_LIBRARIES_JDK_LIBS_libstringPlatformChars := java.base:libjava java.base:libjvm
 BUILD_JDK_JTREG_LIBRARIES_JDK_LIBS_libTracePinnedThreads := java.base:libjvm
-BUILD_JDK_JTREG_LIBRARIES_JDK_LIBS_libNewDirectByteBuffer := java.base:libjava
-BUILD_JDK_JTREG_LIBRARIES_JDK_LIBS_libGetXSpace := java.base:libjava
+BUILD_JDK_JTREG_LIBRARIES_JDK_LIBS_libNewDirectByteBuffer := java.base:libjava java.base:libjvm
+BUILD_JDK_JTREG_LIBRARIES_JDK_LIBS_libGetXSpace := java.base:libjava java.base:libjvm
 
 # Platform specific setup
 ifeq ($(call isTargetOs, windows), true)
@@ -75,7 +75,7 @@
   BUILD_JDK_JTREG_EXECUTABLES_LIBS_exerevokeall := advapi32.lib
   BUILD_JDK_JTREG_EXECUTABLES_CFLAGS_exeNullCallerTest := /EHsc
 else
-  BUILD_JDK_JTREG_LIBRARIES_JDK_LIBS_libDirectIO := java.base:libjava
+  BUILD_JDK_JTREG_LIBRARIES_JDK_LIBS_libDirectIO := java.base:libjava java.base:libjvm
   BUILD_JDK_JTREG_LIBRARIES_LDFLAGS_libNativeThread := -pthread
 
   # java.lang.foreign tests
@@ -92,6 +92,9 @@
   ifeq ($(call isTargetOs, linux), true)
     BUILD_JDK_JTREG_LIBRARIES_JDK_LIBS_libInheritedChannel := java.base:libjava
     BUILD_JDK_JTREG_EXECUTABLES_LIBS_exelauncher := -ldl
+  else ifeq ($(call isTargetOs, solaris), true)
+    BUILD_JDK_JTREG_LIBRARIES_JDK_LIBS_libInheritedChannel := java.base:libjava java.base:libjvm
+    BUILD_JDK_JTREG_EXECUTABLES_LIBS_exelauncher := -lsocket -lnsl -lthread -ldl
   endif
   BUILD_JDK_JTREG_EXECUTABLES_LIBS_exeNullCallerTest := $(LIBCXX)
 endif
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/cpu/x86/globalDefinitions_x86.hpp jdk24u-jdk-24-29/src/hotspot/cpu/x86/globalDefinitions_x86.hpp
--- jdk24u-jdk-24-29.orig/src/hotspot/cpu/x86/globalDefinitions_x86.hpp	2024-12-29 15:19:43.881468590 +0100
+++ jdk24u-jdk-24-29/src/hotspot/cpu/x86/globalDefinitions_x86.hpp	2024-12-29 15:20:25.065428060 +0100
@@ -54,7 +54,7 @@
 #define DEFAULT_PADDING_SIZE DEFAULT_CACHE_LINE_SIZE
 #endif
 
-#if defined(LINUX) || defined(__APPLE__)
+#if defined(LINUX) || defined(SOLARIS) || defined(__APPLE__)
 #define SUPPORT_RESERVED_STACK_AREA
 #endif
 
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/os/posix/include/jvm_md.h jdk24u-jdk-24-29/src/hotspot/os/posix/include/jvm_md.h
--- jdk24u-jdk-24-29.orig/src/hotspot/os/posix/include/jvm_md.h	2024-12-29 15:19:43.850726619 +0100
+++ jdk24u-jdk-24-29/src/hotspot/os/posix/include/jvm_md.h	2024-12-29 15:20:25.065874413 +0100
@@ -47,7 +47,7 @@
 #endif
 #define JNI_LIB_NAME(NAME) JNI_LIB_PREFIX NAME JNI_LIB_SUFFIX
 
-#if defined(AIX)
+#if defined(AIX) || defined(SOLARIS)
 #define JVM_MAXPATHLEN MAXPATHLEN
 #else
 // Hack: MAXPATHLEN is 4095 on some Linux and 4096 on others. This may
@@ -80,6 +80,9 @@
 #define JVM_SIGTERM    SIGTERM
 
 #define BREAK_SIGNAL     SIGQUIT           /* Thread dumping support.    */
+#ifdef SOLARIS
+#define ASYNC_SIGNAL     SIGJVM2           /* Event-based suspend/resume support */
+#endif // SOLARIS
 #define SHUTDOWN1_SIGNAL SIGHUP            /* Shutdown Hooks support.    */
 #define SHUTDOWN2_SIGNAL SIGINT
 #define SHUTDOWN3_SIGNAL SIGTERM
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/os/posix/os_posix.cpp jdk24u-jdk-24-29/src/hotspot/os/posix/os_posix.cpp
--- jdk24u-jdk-24-29.orig/src/hotspot/os/posix/os_posix.cpp	2024-12-29 15:19:43.851756327 +0100
+++ jdk24u-jdk-24-29/src/hotspot/os/posix/os_posix.cpp	2024-12-29 15:20:25.066524583 +0100
@@ -596,7 +596,7 @@
   st->print("%ld", sysconf(_SC_CHILD_MAX));
 
   print_rlimit(st, ", THREADS", RLIMIT_THREADS);
-#else
+#elif !defined(SOLARIS)
   print_rlimit(st, ", NPROC", RLIMIT_NPROC);
 #endif
 
@@ -614,6 +614,12 @@
   print_rlimit(st, ", MEMLOCK", RLIMIT_MEMLOCK, true);
 #endif
 
+#if defined(SOLARIS)
+  // maximum size of mapped address space of a process in bytes;
+  // if the limit is exceeded, mmap and brk fail
+  print_rlimit(st, ", VMEM", RLIMIT_VMEM, true);
+#endif
+
   // MacOS; The maximum size (in bytes) to which a process's resident set size may grow.
 #if defined(__APPLE__)
   print_rlimit(st, ", RSS", RLIMIT_RSS, true);
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/os/posix/os_posix.inline.hpp jdk24u-jdk-24-29/src/hotspot/os/posix/os_posix.inline.hpp
--- jdk24u-jdk-24-29.orig/src/hotspot/os/posix/os_posix.inline.hpp	2024-12-29 15:19:43.853207918 +0100
+++ jdk24u-jdk-24-29/src/hotspot/os/posix/os_posix.inline.hpp	2024-12-29 15:20:25.066856941 +0100
@@ -34,8 +34,10 @@
 #include <sys/socket.h>
 #include <netdb.h>
 
+#ifndef SOLARIS
 // Aix does not have NUMA support but need these for compilation.
 inline bool os::numa_has_group_homing()     { AIX_ONLY(ShouldNotReachHere();) return false;  }
+#endif // !SOLARIS
 
 // Platform Mutex/Monitor implementation
 
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/os/posix/vmError_posix.cpp jdk24u-jdk-24-29/src/hotspot/os/posix/vmError_posix.cpp
--- jdk24u-jdk-24-29.orig/src/hotspot/os/posix/vmError_posix.cpp	2024-12-29 15:19:43.852643683 +0100
+++ jdk24u-jdk-24-29/src/hotspot/os/posix/vmError_posix.cpp	2024-12-29 15:20:25.067184764 +0100
@@ -41,6 +41,9 @@
 #include <sys/syscall.h>
 #include <unistd.h>
 #endif
+#ifdef SOLARIS
+#include <thread.h>
+#endif
 #ifdef AIX
 #include <unistd.h>
 #endif
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/share/c1/c1_LIR.cpp jdk24u-jdk-24-29/src/hotspot/share/c1/c1_LIR.cpp
--- jdk24u-jdk-24-29.orig/src/hotspot/share/c1/c1_LIR.cpp	2024-12-29 15:19:44.561293086 +0100
+++ jdk24u-jdk-24-29/src/hotspot/share/c1/c1_LIR.cpp	2024-12-29 15:20:25.067897390 +0100
@@ -452,6 +452,8 @@
     case lir_monaddr:        // input and result always valid, info always invalid
     case lir_null_check:     // input and info always valid, result always invalid
     case lir_move:           // input and result always valid, may have info
+    case lir_pack64:         // input and result always valid
+    case lir_unpack64:       // input and result always valid
     {
       assert(op->as_Op1() != nullptr, "must be");
       LIR_Op1* op1 = (LIR_Op1*)op;
@@ -1736,6 +1738,8 @@
      case lir_convert:               s = "convert";       break;
      case lir_alloc_object:          s = "alloc_obj";     break;
      case lir_monaddr:               s = "mon_addr";      break;
+     case lir_pack64:                s = "pack64";        break;
+     case lir_unpack64:              s = "unpack64";      break;
      // LIR_Op2
      case lir_cmp:                   s = "cmp";           break;
      case lir_cmp_l2i:               s = "cmp_l2i";       break;
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/share/c1/c1_LIR.hpp jdk24u-jdk-24-29/src/hotspot/share/c1/c1_LIR.hpp
--- jdk24u-jdk-24-29.orig/src/hotspot/share/c1/c1_LIR.hpp	2024-12-29 15:19:44.562078817 +0100
+++ jdk24u-jdk-24-29/src/hotspot/share/c1/c1_LIR.hpp	2024-12-29 15:20:25.068700119 +0100
@@ -940,6 +940,8 @@
       , lir_monaddr
       , lir_roundfp
       , lir_safepoint
+      , lir_pack64
+      , lir_unpack64
       , lir_unwind
       , lir_load_klass
   , end_op1
@@ -2239,6 +2241,9 @@
   void logical_or  (LIR_Opr left, LIR_Opr right, LIR_Opr dst) { append(new LIR_Op2(lir_logic_or,   left, right, dst)); }
   void logical_xor (LIR_Opr left, LIR_Opr right, LIR_Opr dst) { append(new LIR_Op2(lir_logic_xor,  left, right, dst)); }
 
+  void   pack64(LIR_Opr src, LIR_Opr dst) { append(new LIR_Op1(lir_pack64,   src, dst, T_LONG, lir_patch_none, NULL)); }
+  void unpack64(LIR_Opr src, LIR_Opr dst) { append(new LIR_Op1(lir_unpack64, src, dst, T_LONG, lir_patch_none, NULL)); }
+
   void null_check(LIR_Opr opr, CodeEmitInfo* info, bool deoptimize_on_null = false);
   void throw_exception(LIR_Opr exceptionPC, LIR_Opr exceptionOop, CodeEmitInfo* info) {
     append(new LIR_Op2(lir_throw, exceptionPC, exceptionOop, LIR_OprFact::illegalOpr, info));
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/share/cds/classListParser.cpp jdk24u-jdk-24-29/src/hotspot/share/cds/classListParser.cpp
--- jdk24u-jdk-24-29.orig/src/hotspot/share/cds/classListParser.cpp	2024-12-29 15:19:44.325037907 +0100
+++ jdk24u-jdk-24-29/src/hotspot/share/cds/classListParser.cpp	2024-12-29 15:20:25.069282551 +0100
@@ -493,7 +493,7 @@
 // This function is used for loading classes for customized class loaders
 // during archive dumping.
 InstanceKlass* ClassListParser::load_class_from_source(Symbol* class_name, TRAPS) {
-#if !(defined(_LP64) && (defined(LINUX) || defined(__APPLE__) || defined(_WINDOWS)))
+#if !(defined(_LP64) && (defined(LINUX)|| defined(SOLARIS) || defined(__APPLE__) || defined(_WINDOWS)))
   // The only supported platforms are: (1) Linux/64-bit and (2) Solaris/64-bit and
   // (3) MacOSX/64-bit and (4) Windowss/64-bit
   // This #if condition should be in sync with the areCustomLoadersSupportedForCDS
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/share/nmt/memTracker.cpp jdk24u-jdk-24-29/src/hotspot/share/nmt/memTracker.cpp
--- jdk24u-jdk-24-29.orig/src/hotspot/share/nmt/memTracker.cpp	2024-12-29 15:19:44.514278783 +0100
+++ jdk24u-jdk-24-29/src/hotspot/share/nmt/memTracker.cpp	2024-12-29 15:20:25.070636942 +0100
@@ -48,6 +48,12 @@
 #include <windows.h>
 #endif
 
+#ifdef SOLARIS
+  volatile bool NMT_stack_walkable = false;
+#else
+  volatile bool NMT_stack_walkable = true;
+#endif
+
 NMT_TrackingLevel MemTracker::_tracking_level = NMT_unknown;
 
 MemBaseline MemTracker::_baseline;
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/share/nmt/memTracker.hpp jdk24u-jdk-24-29/src/hotspot/share/nmt/memTracker.hpp
--- jdk24u-jdk-24-29.orig/src/hotspot/share/nmt/memTracker.hpp	2024-12-29 15:19:44.515838269 +0100
+++ jdk24u-jdk-24-29/src/hotspot/share/nmt/memTracker.hpp	2024-12-29 15:20:25.070989421 +0100
@@ -35,9 +35,11 @@
 #include "utilities/debug.hpp"
 #include "utilities/nativeCallStack.hpp"
 
-#define CURRENT_PC ((MemTracker::tracking_level() == NMT_detail) ? \
+extern volatile bool NMT_stack_walkable;
+
+#define CURRENT_PC ((MemTracker::tracking_level() == NMT_detail && NMT_stack_walkable) ? \
                     NativeCallStack(0) : FAKE_CALLSTACK)
-#define CALLER_PC  ((MemTracker::tracking_level() == NMT_detail) ?  \
+#define CALLER_PC  ((MemTracker::tracking_level() == NMT_detail && NMT_stack_walkable) ?  \
                     NativeCallStack(1) : FAKE_CALLSTACK)
 
 class MemBaseline;
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/share/runtime/abstract_vm_version.cpp jdk24u-jdk-24-29/src/hotspot/share/runtime/abstract_vm_version.cpp
--- jdk24u-jdk-24-29.orig/src/hotspot/share/runtime/abstract_vm_version.cpp	2024-12-29 15:19:44.432849856 +0100
+++ jdk24u-jdk-24-29/src/hotspot/share/runtime/abstract_vm_version.cpp	2024-12-29 15:20:25.069877513 +0100
@@ -171,6 +171,7 @@
 
 #define OS       LINUX_ONLY("linux")             \
                  WINDOWS_ONLY("windows")         \
+                 SOLARIS_ONLY("solaris")         \
                  AIX_ONLY("aix")                 \
                  BSD_ONLY("bsd")
 
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/share/runtime/semaphore.hpp jdk24u-jdk-24-29/src/hotspot/share/runtime/semaphore.hpp
--- jdk24u-jdk-24-29.orig/src/hotspot/share/runtime/semaphore.hpp	2024-12-29 15:19:44.435349254 +0100
+++ jdk24u-jdk-24-29/src/hotspot/share/runtime/semaphore.hpp	2024-12-29 15:20:25.070209400 +0100
@@ -28,7 +28,7 @@
 #include "memory/allocation.hpp"
 #include "utilities/globalDefinitions.hpp"
 
-#if defined(LINUX) || defined(AIX)
+#if defined(LINUX) || defined(SOLARIS) || defined(AIX)
 # include "semaphore_posix.hpp"
 #else
 # include OS_HEADER(semaphore)
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/share/services/dtraceAttacher.cpp jdk24u-jdk-24-29/src/hotspot/share/services/dtraceAttacher.cpp
--- jdk24u-jdk-24-29.orig/src/hotspot/share/services/dtraceAttacher.cpp	1970-01-01 01:00:00.000000000 +0100
+++ jdk24u-jdk-24-29/src/hotspot/share/services/dtraceAttacher.cpp	2024-12-29 15:20:25.108656505 +0100
@@ -0,0 +1,99 @@
+/*
+ * Copyright (c) 2006, 2019, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#include "precompiled.hpp"
+#include "code/codeCache.hpp"
+#include "memory/resourceArea.hpp"
+#include "runtime/deoptimization.hpp"
+#include "runtime/flags/jvmFlag.hpp"
+#include "runtime/vmThread.hpp"
+#include "runtime/vmOperations.hpp"
+#include "services/dtraceAttacher.hpp"
+#include "runtime/flags/jvmFlagAccess.hpp"
+
+#ifdef SOLARIS
+
+static void set_bool_flag(const char* name, bool value) {
+  JVMFlag* flag = JVMFlag::find_flag(name);
+  JVMFlagAccess::set_bool(flag, &value, JVMFlagOrigin::ATTACH_ON_DEMAND);
+}
+
+// Enable the "fine grained" flags.
+void DTrace::enable_dprobes(int probes) {
+  bool changed = false;
+  if (!DTraceAllocProbes && (probes & DTRACE_ALLOC_PROBES)) {
+    set_bool_flag("DTraceAllocProbes", true);
+    changed = true;
+  }
+  if (!DTraceMethodProbes && (probes & DTRACE_METHOD_PROBES)) {
+    set_bool_flag("DTraceMethodProbes", true);
+    changed = true;
+  }
+  if (!DTraceMonitorProbes && (probes & DTRACE_MONITOR_PROBES)) {
+    set_bool_flag("DTraceMonitorProbes", true);
+    changed = true;
+  }
+
+  if (changed) {
+    // one or more flags changed, need to deoptimize
+    DeoptimizationScope deopt_scope;
+    CodeCache::mark_all_nmethods_for_deoptimization(&deopt_scope);
+    deopt_scope.deoptimize_marked();
+  }
+}
+
+// Disable the "fine grained" flags.
+void DTrace::disable_dprobes(int probes) {
+  bool changed = false;
+  if (DTraceAllocProbes && (probes & DTRACE_ALLOC_PROBES)) {
+    set_bool_flag("DTraceAllocProbes", false);
+    changed = true;
+  }
+  if (DTraceMethodProbes && (probes & DTRACE_METHOD_PROBES)) {
+    set_bool_flag("DTraceMethodProbes", false);
+    changed = true;
+  }
+  if (DTraceMonitorProbes && (probes & DTRACE_MONITOR_PROBES)) {
+    set_bool_flag("DTraceMonitorProbes", false);
+    changed = true;
+  }
+  if (changed) {
+    // one or more flags changed, need to deoptimize
+    DeoptimizationScope deopt_scope;
+    CodeCache::mark_all_nmethods_for_deoptimization(&deopt_scope);
+    deopt_scope.deoptimize_marked();
+  }
+}
+
+// Do clean-up on "all door clients detached" event.
+void DTrace::detach_all_clients() {
+  disable_dprobes(DTRACE_ALL_PROBES);
+}
+
+void DTrace::set_monitor_dprobes(bool flag) {
+  // explicit setting of DTraceMonitorProbes flag
+  set_bool_flag("DTraceMonitorProbes", flag);
+}
+
+#endif /* SOLARIS */
diff -Nru jdk24u-jdk-24-29.orig/src/hotspot/share/utilities/debug.cpp jdk24u-jdk-24-29/src/hotspot/share/utilities/debug.cpp
--- jdk24u-jdk-24-29.orig/src/hotspot/share/utilities/debug.cpp	2024-12-29 15:19:44.107612010 +0100
+++ jdk24u-jdk-24-29/src/hotspot/share/utilities/debug.cpp	2024-12-29 15:20:25.071553653 +0100
@@ -620,11 +620,12 @@
   tty->print_cr("  findm(intptr_t pc) - finds Method*");
   tty->print_cr("  find(intptr_t x)   - finds & prints nmethod/stub/bytecode/oop based on pointer into it");
   tty->print_cr("  pns(void* sp, void* fp, void* pc)  - print native (i.e. mixed) stack trace. E.g.");
-  tty->print_cr("                   pns($sp, $rbp, $pc) on Linux/amd64 or");
+  tty->print_cr("                   pns($sp, $rbp, $pc) on Linux/amd64 and Solaris/amd64 or");
   tty->print_cr("                   pns($sp, $ebp, $pc) on Linux/x86 or");
   tty->print_cr("                   pns($sp, $fp, $pc)  on Linux/AArch64 or");
   tty->print_cr("                   pns($sp, 0, $pc)    on Linux/ppc64 or");
   tty->print_cr("                   pns($sp, $s8, $pc)  on Linux/mips or");
+  tty->print_cr("                   pns($sp + 0x7ff, 0, $pc) on Solaris/SPARC");
   tty->print_cr("                 - in gdb do 'set overload-resolution off' before calling pns()");
   tty->print_cr("                 - in dbx do 'frame 1' before calling pns()");
   tty->print_cr("class metadata.");
